﻿#Region " Imports "
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Data

Imports Infragistics.Web.UI.Framework
Imports Infragistics.Web.UI.GridControls
#End Region

Public Class _Default
    Inherits System.Web.UI.Page

#Region " Constants "
    Private Const RECORD_COUNT As Integer = 50
    Private Const HIDDEN_FIELDNAME_PREFIX As String = "Hidden "
    Private Const DEF_COLUMN_WIDTH As Integer = 80
    Private Const DEF_PAGE_SIZE As Integer = 25

    Private Const DETAILS_STRING As String = "Etsi difficiile esse videtur credere quicquam" & _
                                             "in rebus solido reperiri corpore posse." & _
                                             "transit enim fulmen caeli per saepta domorum," & _
                                             "clamor ut ad voces; flamen candescit in igni" & _
                                             "dissiliuntque ferre ferventi saxa vapore." & _
                                             "tum labefactatus rigor auri solvitur aestu;" & _
                                             "tum glacies aeris flamma devicta liquescit;" & _
                                             "permanat calor argentum penetraleque frigus" & _
                                             "quando utrumque manu retinentes pocula rite" & _
                                             "sensimus infuso lympharum rore superne."
#End Region

#Region " Declarations "
    Private sMessage As String = String.Empty
    Private _dsData As DataSet
#End Region

#Region " Classes "
    Protected Class CSSClass
        Public Const GridRow As String = "gridrow"
        Public Const SelectedGridRow As String = "gridselectedrow"
    End Class
#End Region

#Region " Page Events "
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim _dsData As New DataSet()
        _dsData.Tables.Add(BuildTable("Parent"))

        If Not (Me.IsPostBack) Then
            Initialize_GridColumns(Me.WebHierarchicalDataGrid1, _dsData)
            Initialize_GridLayout(Me.WebHierarchicalDataGrid1)
        End If

        Me.WebHierarchicalDataGrid1.DataKeyFields = "id"
        Me.WebHierarchicalDataGrid1.DataSource = _dsData

    End Sub
#End Region

#Region " Events "
    Protected Sub WebHierarchicalDataGrid1_ColumnMoved(sender As Object, e As ColumnMovingEventArgs) Handles WebHierarchicalDataGrid1.ColumnMoved
        sMessage = String.Format("Column moved is {0}", e.Column.Key)
    End Sub

    Protected Sub WebHierarchicalDataGrid1_ColumnResized(sender As Object, e As ColumnResizingEventArgs) Handles WebHierarchicalDataGrid1.ColumnResized
        sMessage = String.Format("Column resized is {0}", e.Column.Key)
    End Sub

    Protected Sub WebHierarchicalDataGrid1_ColumnSorted(sender As Object, e As SortingEventArgs) Handles WebHierarchicalDataGrid1.ColumnSorted
        sMessage = String.Format("Column sorted is {0}", e.Column.Key)
    End Sub

    Private Sub WebHierarchicalDataGrid1_InitializeRow(sender As Object, e As RowEventArgs) Handles WebHierarchicalDataGrid1.InitializeRow
        If IsRowOnCurrentGridPage(Me.WebHierarchicalDataGrid1, e.Row.Index) Then
            Initialize_HierarchicalGridRow(e)
        End If
    End Sub
#End Region

#Region " Methods "
    Private Sub Initialize_GridLayout(ByRef grid As WebHierarchicalDataGrid)
        grid.GridView.Behaviors.Paging.PageSize = DEF_PAGE_SIZE
    End Sub

    Private Sub Initialize_GridColumns(ByRef grid As WebHierarchicalDataGrid, ByVal dsData As DataSet)
        If Me.WebHierarchicalDataGrid1.Columns.Count > 0 Then
            Me.WebHierarchicalDataGrid1.Columns.Clear()
        End If

        For i As Integer = 0 To dsData.Tables(0).Columns.Count - 1

            Initialize_HierarchicalGridColumn(grid.GridView, _
                                              dsData.Tables(0).Columns.Item(i), _
                                              dsData.Tables(0).Columns.Item(i).ColumnName.Contains(HIDDEN_FIELDNAME_PREFIX.Trim))
            Format_HierarchicalGridColumn(grid.GridView, _
                                          dsData.Tables(0).Columns.Item(i), _
                                          dsData.Tables(0).Columns.Item(i).ColumnName.Contains(HIDDEN_FIELDNAME_PREFIX.Trim))

        Next
    End Sub

    Private Sub Initialize_HierarchicalGridColumn(ByRef band As IBand, ByVal oDataColumn As DataColumn, ByVal hidden As Boolean)
        Dim column As New BoundDataField()
        column.Key = oDataColumn.ColumnName
        column.DataType = oDataColumn.DataType.ToString
        column.DataFieldName = oDataColumn.ColumnName

        column.Header.Text = oDataColumn.ColumnName
        column.Header.Tooltip = oDataColumn.ColumnName
        column.Width = Unit.Pixel(DEF_COLUMN_WIDTH)

        band.Columns.Add(column)
    End Sub

    Private Sub Format_HierarchicalGridColumn(ByRef band As IBand, ByVal oDataColumn As DataColumn, ByVal hidden As Boolean)
        band.Columns(oDataColumn.ColumnName).Hidden = hidden
        band.Columns(oDataColumn.ColumnName).Width = Unit.Pixel(DEF_COLUMN_WIDTH)
    End Sub

    Private Sub Initialize_HierarchicalGridRow(ByRef e As Infragistics.Web.UI.GridControls.RowEventArgs)
        Dim sClass As String = ""
        'sClass = AppStyling.AppStylingManager.Settings.CssRegistry.Add(
        '    create_RowCssClass("24px"), "tbody  tr.{0}  td", False)
        e.Row.CssClass = CSSClass.GridRow 'sClass
        If e.Row.Items.Count > 0 Then 'Make sure there are columns to process
            For i As Integer = 0 To e.Row.Items.Count - 1
                With e.Row.Items.Item(i) 'Iterate through row cells and apply CssClasses
                    Select Case .Column.Header.FieldKey
                        Case "id"
                            .Text = HttpUtility.HtmlEncode(.Value.ToString.Trim)
                            .Tooltip = HttpUtility.HtmlEncode(.Value.ToString.Trim)
                            sClass = AppStyling.AppStylingManager.Settings.CssRegistry.Add(
                                create_FontCssClass("red"), "tbody  tr  td.{0}", False)
                            .CssClass = sClass
                        Case "Item"
                            .Text = HttpUtility.HtmlEncode(.Value.ToString.Trim)
                            .Tooltip = HttpUtility.HtmlEncode(.Value.ToString.Trim)
                            sClass = AppStyling.AppStylingManager.Settings.CssRegistry.Add(
                                create_FontCssClass("black"), "tbody  tr  td.{0}", False)
                            .CssClass = sClass
                        Case "Data"
                            .Text = HttpUtility.HtmlEncode(.Value.ToString.Trim)
                            .Tooltip = HttpUtility.HtmlEncode(.Value.ToString.Trim)
                            sClass = AppStyling.AppStylingManager.Settings.CssRegistry.Add(
                                create_FontCssClass("black"), "tbody  tr  td.{0}", False)
                            .CssClass = sClass
                        Case "Data1"
                            .Text = String.Empty
                            .Tooltip = HttpUtility.HtmlEncode(.Value.ToString.Trim)
                            If e.Row.Index Mod 2 Then
                                sClass = AppStyling.AppStylingManager.Settings.CssRegistry.Add(create_ImageCssClass() & "background-image: url(""" & _
                                                                            get_ImagePath("Smile") & """);", "tbody tr td.{0}", False)
                                .CssClass = sClass ' Odds
                            Else
                                sClass = AppStyling.AppStylingManager.Settings.CssRegistry.Add(create_ImageCssClass() & "background-image: url(""" & _
                                                                            get_ImagePath("Sad") & """);", "tbody tr td.{0}", False)
                                .CssClass = sClass ' Evens
                            End If
                    End Select
                End With
            Next
        End If
    End Sub

    Private Function create_RowCssClass(ByVal strRowHeight As String) As String
        Dim sClass As String = String.Format("height:{0};", strRowHeight)
        Return sClass
    End Function

    Private Function create_FontCssClass(ByVal strColour As String) As String
        Dim sClass As String = String.Format("background-position:center; " & _
                                             "background-repeat:no-repeat; " & _
                                             "border-bottom:solid 1px #D8D8D8; " & _
                                             "overflow: hidden; " & _
                                             "text-overflow:ellipsis; " & _
                                             "white-space:nowrap; " & _
                                             "color:{0};", strColour)
        Return sClass
    End Function

    Protected Overridable Function GetClientIncludes() As String
        Return String.Format( _
            "<script type=""text/javascript"" src=""{0}""></script>", "JScript.js")
    End Function

    Private Function create_ImageCssClass() As String
        Dim sClass As String = "padding-left:4px;" & _
                               "padding-right:2px;" & _
                               "padding-top:2px;" & _
                               "padding-bottom:2px;" & _
                               "border-bottom:solid 1px #D8D8D8;" & _
                               "background-position:center;" & _
                               "background-repeat:no-repeat; "
        Return sClass
    End Function

    Private Function get_ImagePath(ByVal sRowCode As String) As String
        Dim strImagePath As String = String.Empty
        Select Case (sRowCode)
            Case "Smile"
                strImagePath = String.Format("images/{0}", "smile.jpg")
            Case "Sad"
                strImagePath = String.Format("images/{0}", "sad.jpg")
        End Select

        Return strImagePath
    End Function

    Private Function IsRowOnCurrentGridPage(ByVal grid As WebHierarchicalDataGrid, ByVal iRowIndex As Integer) As Boolean

        Dim iPageIndex As Integer = grid.GridView.Behaviors.Paging.PageIndex
        Dim iPageSize As Integer = grid.GridView.Behaviors.Paging.PageSize
        Dim nLBound As Integer = ((iPageIndex) * iPageSize) '((iPageIndex - 1) * iPageSize)
        Dim nUBound As Integer = nLBound + iPageSize + 1
        Dim iCurrentRow As Integer = nLBound + iRowIndex

        If (iCurrentRow >= nLBound) And (iCurrentRow <= nUBound) Then
            Return True
        Else
            Return False
        End If

    End Function
#End Region

#Region " Overrides "
    Protected Overrides Sub OnPreRender(ByVal e As System.EventArgs)
        MyBase.OnPreRender(e)

        ' Register client script
        Dim strScriptKey As String = Me.GetType().ToString()

        If Not (ClientScript.IsClientScriptBlockRegistered(strScriptKey)) Then
            ClientScript.RegisterClientScriptBlock(GetType(Page), strScriptKey, Me.GetClientIncludes())
        End If

        ' Register start-up script
        If Not (ClientScript.IsStartupScriptRegistered(strScriptKey)) Then
            Dim sbScript As New StringBuilder("<script type=""text/javascript"">")
            sbScript.Append(vbNewLine)
            sbScript.Append("<!--")
            sbScript.Append(vbNewLine)
            If (Me.IsPostBack) Then
                sbScript.AppendFormat("alert(""{0}"");", sMessage)
                sbScript.Append(vbNewLine)
            End If
            sbScript.Append(vbNewLine)
            sbScript.Append("//-->")
            sbScript.Append(vbNewLine)
            sbScript.Append("</script>")
            ClientScript.RegisterStartupScript(GetType(Page), strScriptKey, sbScript.ToString)
        End If

        'Initialize_GridLayout(Me.WebHierarchicalDataGrid1)

    End Sub
#End Region

#Region " Data "
    Private Function BuildTable(name As String) As DataTable

        Dim table As System.Data.DataTable = New DataTable(name)
        Dim column As DataColumn
        Dim row As DataRow

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "id"
        column.[ReadOnly] = True
        table.Columns.Add(column)

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Item"
        column.AutoIncrement = False
        column.Caption = "Item"
        column.[ReadOnly] = False
        column.Unique = False
        table.Columns.Add(column)

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Data"
        column.AutoIncrement = False
        column.Caption = "Data"
        column.[ReadOnly] = False
        column.Unique = False
        table.Columns.Add(column)

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Data1"
        column.AutoIncrement = False
        column.Caption = "Data1"
        column.[ReadOnly] = False
        column.Unique = False
        table.Columns.Add(column)

        Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
        PrimaryKeyColumns(0) = table.Columns("id")
        table.PrimaryKey = PrimaryKeyColumns

        For i As Integer = 0 To RECORD_COUNT
            row = table.NewRow()
            row("id") = i
            row("Item") = "Item " & i
            row("Data") = "Data - &amp;" & DETAILS_STRING & " [" & i & "]."
            row("Data1") = "Data 1 &" & i
            table.Rows.Add(row)
        Next
        Return table

    End Function

    Private Function BuildChildTable(name As String) As DataTable
        Dim table As System.Data.DataTable = New DataTable(name)
        Dim column As DataColumn
        Dim row As DataRow

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "id"
        column.[ReadOnly] = True
        table.Columns.Add(column)

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Item"
        column.AutoIncrement = False
        column.Caption = "Item"
        column.[ReadOnly] = False
        column.Unique = False
        table.Columns.Add(column)

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Data"
        column.AutoIncrement = False
        column.Caption = "Data"
        column.[ReadOnly] = False
        column.Unique = False
        table.Columns.Add(column)

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.String")
        column.ColumnName = "Data1"
        column.AutoIncrement = False
        column.Caption = "Data1"
        column.[ReadOnly] = False
        column.Unique = False
        table.Columns.Add(column)

        column = New DataColumn()
        column.DataType = System.Type.[GetType]("System.Int32")
        column.ColumnName = "relation"
        column.AutoIncrement = False
        column.Caption = "relation"
        column.[ReadOnly] = False
        column.Unique = False
        table.Columns.Add(column)

        Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
        PrimaryKeyColumns(0) = table.Columns("id")
        table.PrimaryKey = PrimaryKeyColumns

        For i As Integer = 0 To 100
            row = table.NewRow()
            row("id") = i
            row("Item") = "Item " & i
            row("Data") = "Data " & i
            row("Data1") = "Data1 " & i

            If (i < 10) AndAlso (i >= 0) Then

                row("relation") = 0
            ElseIf (i < 20) AndAlso (i >= 10) Then
                row("relation") = 1
            ElseIf (i < 30) AndAlso (i >= 20) Then
                row("relation") = 2
            ElseIf (i < 40) AndAlso (i >= 30) Then
                row("relation") = 3
            ElseIf (i < 50) AndAlso (i >= 40) Then
            End If
            table.Rows.Add(row)
        Next
        Return table

    End Function
#End Region
End Class